import { __assign } from './../external/tslib/tslib.es6.js';
import { Typography } from '@highlight-ui/typography';
import { forkHandlers, parseMetadata } from '@highlight-ui/utils-commons';
import { useAutoPositioner, useForkRef } from '@highlight-ui/utils-hooks';
import { GroupedPortal } from '@highlight-ui/utils-portal-manager';
import classnames from 'classnames';
import uniqueId from 'lodash/uniqueId';
import React, { cloneElement } from 'react';
import styles from './Tooltip.module.scss.js';
import { useTooltipVisibility } from './useTooltipVisibility.js';

var Tooltip = function (_a) {
  var // TODO: [PPUI-75] Make generated id consistent on every re-render.
  _b = _a.id,
      // TODO: [PPUI-75] Make generated id consistent on every re-render.
  id = _b === void 0 ? uniqueId('tooltip-') : _b,
      children = _a.children,
      content = _a.content,
      _c = _a.mouseEnterDelay,
      mouseEnterDelay = _c === void 0 ? 'none' : _c,
      _d = _a.mouseOutDelay,
      mouseOutDelay = _d === void 0 ? 'none' : _d,
      metadata = _a.metadata,
      _e = _a.interactive,
      interactive = _e === void 0 ? false : _e,
      _f = _a.placement,
      placement = _f === void 0 ? 'top' : _f;

  var _g = useTooltipVisibility(mouseEnterDelay, mouseOutDelay, interactive),
      isVisible = _g[0],
      handleTriggerMouseOver = _g[1],
      handleTooltipMouseEnter = _g[2],
      handleMouseLeave = _g[3];

  var _h = useAutoPositioner({
    placement: placement
  }),
      setReferenceElement = _h.setReferenceElement,
      setPopperElement = _h.setPopperElement,
      popperStyles = _h.styles.popper,
      attributes = _h.attributes;

  var childRef = useForkRef([setReferenceElement, // TODO: Get rid of any type when working on PPUI-357
  children.ref]);
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/cloneElement(children, __assign({
    className: classnames(children.props.className, styles.trigger),
    ref: childRef,
    onMouseOver: forkHandlers([content ? handleTriggerMouseOver : null, children.props.onMouseOver]),
    onMouseLeave: forkHandlers([content ? handleMouseLeave : null, children.props.onMouseLeave])
  }, parseMetadata(metadata))), content && isVisible && /*#__PURE__*/React.createElement(GroupedPortal, null, /*#__PURE__*/React.createElement("div", __assign({
    role: "tooltip",
    className: styles.tooltip,
    id: id,
    ref: setPopperElement,
    style: popperStyles,
    onMouseEnter: handleTooltipMouseEnter,
    onMouseLeave: handleMouseLeave
  }, attributes.popper), /*#__PURE__*/React.createElement(Typography, {
    variant: "caption-2"
  }, content))));
};

export { Tooltip as default };
//# sourceMappingURL=Tooltip.js.map
